// Copyright (c) 2015, <your name>. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

library rabbits;

import 'dart:html';
import 'dart:math';

const int GROWTH_FACTOR = 15;

initRabbits() {
  querySelector('#submit').onClick.listen( (e) => calcRabbits() );
}

calcRabbits() {
  // binding variables to html elements:
  InputElement yearsInput = querySelector("#years");
  LabelElement output = querySelector("#output");
  // getting input
  String yearsString = yearsInput.value;
  int years = int.parse(yearsString);
  // calculating and setting output:
  output.innerHtml = "${calculateRabbits(years)}";
}

int calculateRabbits(int years) {
  return (2 * pow(E, log(GROWTH_FACTOR) *
                  years)).round().toInt();
}
