// Copyright (c) 2015, <your name>. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

import 'dart:html';

import 'package:dart_apps/nav_menu.dart';
import 'package:dart_apps/reverser.dart';
import 'package:dart_apps/rabbits.dart';
import 'package:route_hierarchical/client.dart';

void main() {
  initNavMenu();
  initReverser();
  initRabbits();

  // Webapps need routing to listen for changes to the URL.
  var router = new Router();
  router.root
    ..addRoute(name: 'about', path: '/about', enter: showAbout)
    ..addRoute(name: 'rabbit', path: '/rabbit', enter: showRabbit)
    ..addRoute(name: 'home', defaultRoute: true, path: '/', enter: showHome);
  router.listen();
}

void showAbout(RouteEvent e) {
  // Extremely simple and non-scalable way to show different views.
  querySelector('#home').style.display = 'none';
  querySelector('#rabbit').style.display = 'none';
  querySelector('#about').style.display = '';
}

void showHome(RouteEvent e) {
  querySelector('#home').style.display = '';
  querySelector('#about').style.display = 'none';
  querySelector('#rabbit').style.display = 'none';
}

void showRabbit(RouteEvent e) {
  querySelector('#rabbit').style.display = '';
  querySelector('#home').style.display = 'none';
  querySelector('#about').style.display = 'none';
}